/******************************************************************************

  $Header: f:\\RCS\\f\\devel\\pilot\\cppconduit\\linksyncconduit\\LinkSyncConduitRawDataImp.h,v 1.4 2002-08-10 20:34:31-04 eshayne Exp eshayne $
  $Revision: 1.4 $
 

  $Log: LinkSyncConduitRawDataImp.h,v $
  Revision 1.4  2002-08-10 20:34:31-04  eshayne
  changed name to Link Synchronizer

  Revision 1.3  2002-07-21 10:24:16-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ES_LINKSYNC_CONDUIT_RAW_DATA_IMP_H
#define ES_LINKSYNC_CONDUIT_RAW_DATA_IMP_H

class LinkSyncConduitRawDataImp
{
public:
	LinkSyncConduitRawDataImp();
	virtual ~LinkSyncConduitRawDataImp();

	unsigned long& GetRefCount();
	unsigned long GetRefCount() const;
	const void* GetData() const;
	void SetData(const void* pData, const unsigned short usSize);
	unsigned short GetSize() const;
	void AddData(const void* pData, const unsigned short usAddSize, const bool bNullDelimiter);
	unsigned short GetAllocatedSize() const;

	void* GetData();
	void Allocate(const unsigned short usSize);

private:
	void* mpData;
	unsigned short musSize;
	unsigned long mulRefCount;
	unsigned short musAllocatedSize;
};

#endif
