/******************************************************************************

  $Header: f:\\RCS\\f\\devel\\pilot\\cppconduit\\linksyncconduitinstaller\\LinkSyncConduitInstallerException.h,v 1.3 2002-08-10 20:37:15-04 eshayne Exp eshayne $
  $Revision: 1.3 $
 

  $Log: LinkSyncConduitInstallerException.h,v $
  Revision 1.3  2002-08-10 20:37:15-04  eshayne
  changed name to Link Synchronizer

  Revision 1.2  2002-07-21 10:24:59-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ES_LINKSYNC_CONDUIT_INSTALLER_EXCEPTION_H
#define ES_LINKSYNC_CONDUIT_INSTALLER_EXCEPTION_H

#include <string>
#include <windows.h>

class LinkSyncConduitInstallerException
{
public:
	LinkSyncConduitInstallerException(const stlport::string& strFilename,
									  const unsigned long ulLineNumber,
									  const stlport::string& strErrorText,
									  const DWORD dwErr = 0);
	LinkSyncConduitInstallerException(const LinkSyncConduitInstallerException& copy);
	LinkSyncConduitInstallerException& operator= (const LinkSyncConduitInstallerException& copy);
	virtual ~LinkSyncConduitInstallerException();


private:
	stlport::string mstrErrorText;
	stlport::string mstrFilename;
	unsigned long mulLineNumber;
	DWORD mdwErr;

friend ostream& operator<< (ostream& s, const LinkSyncConduitInstallerException& e);
};


#endif