/******************************************************************************

  $Header: f:\\RCS\\f\\devel\\pilot\\cppconduit\\linksyncconduit\\LinkSyncConduitRawData.h,v 1.4 2002-08-10 20:34:31-04 eshayne Exp eshayne $
  $Revision: 1.4 $
 

  $Log: LinkSyncConduitRawData.h,v $
  Revision 1.4  2002-08-10 20:34:31-04  eshayne
  changed name to Link Synchronizer

  Revision 1.3  2002-07-21 10:24:17-04  eshayne
  added comment and license blocks


	----------------------------------------
    Link Synchronizer
    Copyright (C)2002 Ethan Shayne

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef ES_LINKSYNC_CONDUIT_RAW_DATA_H
#define ES_LINKSYNC_CONDUIT_RAW_DATA_H

#include "LinkSyncConduitRawDataImp.h"

class LinkSyncConduitRawData
{
public:
	LinkSyncConduitRawData();
	LinkSyncConduitRawData(const void* pData, const unsigned short usSize);
	LinkSyncConduitRawData(const LinkSyncConduitRawData& copy);
	LinkSyncConduitRawData& operator= (const LinkSyncConduitRawData& copy);
	virtual ~LinkSyncConduitRawData();

	void SetData(const void* pData, const unsigned short usSize);
	const void* GetData() const;
	unsigned short GetSize() const;
	unsigned short GetAllocatedSize() const;

	void AddData(const void* pData, const unsigned short usAddSize, const bool bNullDelimiter = true);

	void* GetData();
	void Allocate(const unsigned short usSize);

private:
	LinkSyncConduitRawDataImp* mpImp;	
};

#endif